/*
 * "Assasin v0.11"
 * 5/March/2003
 *
 *   Anotherslave	
 *			<anotherslave@hotmail.com>
 * 
 * This software is released under the terms of the GPL.
 * 
 * A copy of this licence can be found at www.gnu.org
 * 
 * Contact authors for permission if you want to use this
 * software, or work derived from it, under other terms.
 *
 *
 * main.c - Game startup
 */




#include <stdio.h>
#include <stdlib.h>
#include "game.h"


char *title_string = "Assasin - version 0.1 ";

char IsMessage(void) {
	char message_waiting = 0;
	/* Code to check for messages goes here */

	if (message_waiting) {
		return 1;
	} else {
		return 0;
	}
}

void *GetMessage(void) {
	void *message;
	/* Code to retrieve message from queue goes here */

	return message;
}

void ProcessMessage(void *message) {
	/* Process the message here */
}

int HandleMouseEvent(SDL_Event *event, SDL_Surface *wscreen, SDL_Surface *wtarget);
void drawtarget(SDL_Surface *xscreen, SDL_Surface *xtarget, SDL_MouseMotionEvent *motion);
void displaycood(SDL_MouseMotionEvent *wmotion);
void deathSequence(SDL_Surface *dsurface, SDL_Surface *dtarget);
void updateScore(SDL_Surface *sscreen, SDL_Surface *starget, int z, int y, int x);
int manipulateEnemy(SDL_Surface *wsurface, SDL_Surface *wtarget, SDL_MouseMotionEvent *wmotion, SDL_MouseButtonEvent *wbutton,  int whatToDo);

int main(int argc, char **argv) {
	void *message;
	
	SDL_Surface	*screen;
	SDL_Surface	*target;
	SDL_Rect	dest;
	SDL_Event	event;
	int		run=1;
	/* Display game title message */
	fprintf(stderr, title_string);

	/* Startup code goes here */

	/* initialize SDL */
	if (SDL_Init(SDL_INIT_VIDEO|SDL_INIT_AUDIO) !=0) {
		fprintf(stderr, "SDL error: %s\n", SDL_GetError());
		return 0;
	}
	atexit(SDL_Quit);

	/* end init SDL */

	/* open a window in X */
	
	screen = SDL_SetVideoMode(
			320, 200, 		/* width and height of window */
			8,			/* 8 bit color depth (256 colors) */
			SDL_HWSURFACE | SDL_DOUBLEBUF	/* video flags */
	);

	if (screen == NULL) {
		fprintf(stderr, "Video error: %s\n", SDL_GetError());
		exit(1);
	}

	SDL_WM_SetCaption(title_string, NULL);
	
	/* load the bitmap with the background and target */	
	target = SDL_LoadBMP("target.bmp");
	
	/* Create a transparent color for the target surface */
	SDL_SetColorKey(target, SDL_SRCCOLORKEY, 0);
	/* Check what the color key is? */
	printf("the colorkey is %ld\n",target->format->colorkey);
	
	/* Make Cursor disappear */
	 SDL_ShowCursor(0);
	
	 /*end open window in X */			

	/* Enter main game loop */
	dest.x=0, dest.y=0, dest.w=320, dest.h=200;
	SDL_BlitSurface(target, NULL, screen, &dest);
	
	while(run) {
		if (SDL_PollEvent(&event)) {	
		switch(event.type){
			case SDL_MOUSEMOTION:
			case SDL_MOUSEBUTTONDOWN:
				run=HandleMouseEvent(&event, screen, target);
				break;
		
		}
		if (run==2) {
			//do death sequence
			deathSequence(screen, target);
			run=1;
		}
		updateScore(screen, target, NULL, NULL, NULL);		
		SDL_Flip(screen);
		
		}
	
	}

	/* Shutdown code goes here */

	return 1;
}

int HandleMouseEvent(SDL_Event *event, SDL_Surface *wscreen, SDL_Surface *wtarget){
	/* Useful pointers to the required event structures */
	SDL_MouseMotionEvent *motion=&event->motion;
	SDL_MouseButtonEvent *button=&event->button;
	int run=1;
	/*Switch based on the event type */
	switch(event->type){
		case SDL_MOUSEMOTION:
			displaycood(motion);
			
			drawtarget(wscreen, wtarget, motion);
			manipulateEnemy(wscreen, wtarget, motion, NULL, 1);	
			break;
/*		printf("Mouse moved to: (%d, %d)\n", motion->x, motion->y);
			break;*/
		case SDL_MOUSEBUTTONDOWN:
			run=manipulateEnemy(wscreen, wtarget, motion, button, 2);
			printf("Exited with mouse button %d pressed at (%d, %d)\n", button->button, button->x, button->y);
				
			break;
	//	default:
	//		break;
	}
	return run;
}

void drawtarget(SDL_Surface *xscreen, SDL_Surface *xtarget, SDL_MouseMotionEvent *xmotion){
	SDL_Rect dest, src, repair, repairsrc; 

		repair.x=(xmotion->x)-(xmotion->xrel);
		repair.y=(xmotion->y)-(xmotion->yrel);

	repair.w=18, repair.h=18;
		repairsrc.x=repair.x, repairsrc.y=repair.y, repairsrc.w=18, repairsrc.h=18;
		
		SDL_BlitSurface(xtarget, &repairsrc, xscreen, &repair);
	
	
	src.x=320, src.y=0, src.w=18, src.h=18;
	dest.x=xmotion->x, dest.y=xmotion->y, dest.w=20, dest.h=20; 
	SDL_BlitSurface(xtarget, &src, xscreen, &dest);
	//SDL_UpdateRects(xscreen, 1, &dest);
 	//SDL_Flip(xscreen);	
	}

int manipulateEnemy(SDL_Surface *wscreen, SDL_Surface *wtarget, SDL_MouseMotionEvent *wmotion, SDL_MouseButtonEvent *wbutton, int whatToDo) {
	static SDL_Rect dest, src, repair, repairsr, whole;
	static int level=1, moveby, score[]={0,0,0};
	static int xleft, xright, xtop, xbottom;
	int i=0;
	
	
	whole.x=0, whole.y=0, whole.w=320, whole.h=200;
	repair.y=82, repair.w=20, repair.h=17;
	repairsr.y=35, repairsr.w=18, repairsr.h=17, repairsr.x=320;
	if (level==1) dest.x=rand()%320, dest.y=82, dest.w=18, dest.h=17;
	
	xleft=dest.x, xright=dest.x+18, xtop=dest.y, xbottom=dest.y+17;	
	src.x=320, src.y=19, src.h=17, src.w=18;
	moveby=rand()%10;
	
	switch(whatToDo) {
		case 1: //draw the enemy with simple AI
			//move enemy right if mouse to the left
			if (wmotion->x+9 < xleft && wmotion->x > xleft-26 && wmotion->y < 120 && wmotion->y > xtop-25) {
				dest.x=dest.x+moveby;
				repair.x=dest.x-moveby;
			}
			//move enemy left if mouse right	
			if (wmotion->x+9 > xright && wmotion->x+9 < xright+25 && wmotion->y <120 && wmotion->y > xtop-25) {
				dest.x=dest.x-moveby;
				repair.x=dest.x+moveby;
			}
	
			//if the sprite goes over the border it gets randomly thrown back in, the whole background is redrawn
			//a variable is changed to let it know what to do, i think it may cause speed problems.

			if (dest.x< 30 | dest.x > 290) {
				i=1;	
				dest.x=rand()%320;
			}
			
			if (i) SDL_BlitSurface(wtarget, NULL, wscreen, &whole);
			if (!i) SDL_BlitSurface(wtarget, &repairsr, wscreen, &repair);	
			SDL_BlitSurface(wtarget, &src, wscreen, &dest);	
			
		
			level=2;	
			return 1;
			break;
		case 2: //process mouse click, if hits target draw the enemy again, but dying
			
			if (wmotion->x+9 >xleft && wmotion->x+9 < xright && wmotion->y+9 > xtop && wmotion->y+9 < xbottom) {
				// can be an extra function add score code here.
				
				score[2]++;
				if (score[2]==10) {
                           		score[1]++;
                               		score[2]=0;
                          	}
                               	if (score[1]==10) {
					score[0]++;
					score[1]=0;
				}
			
				updateScore(wscreen,wtarget, score[0], score[1], score[2]);			
				printf("\nYour score is %d%d%d\n",score[0],score[1],score[2]);
					
				//animate the death here
				level=1;	
				return 2;
			}	
			if (wbutton->button==3) return 0;

			break;
	}
			

}

void deathSequence(SDL_Surface *dsurface, SDL_Surface *dtarget) {
	
	SDL_Rect dest, src, repair;
	int y;
	repair.x=100, repair.y=0, repair.w=18, repair.h=17;
	dest.x=0, dest.y=0, dest.w=18, dest.h=17;
	src.x=320, src.y=52, src.w=18, src.h=17;
	SDL_BlitSurface(dtarget, NULL, dsurface, &dest);
	SDL_Flip(dsurface);
	dest.x=100;
	//basically with the repair it has to clear each pixel, otherwise the animation is a blurrrrr	
	for (y=1;y<121;y++) {
	//SDL_UpdateRect ( dsurface , 0 , 0 , 0 , 0 ) ;	
		

		dest.y=y-1, dest.h=1;
		SDL_BlitSurface(dtarget, &repair, dsurface, &dest);
		dest.y=y;
		dest.h=17;
		repair.y=y;
		SDL_BlitSurface(dtarget, &src, dsurface, &dest);
		//SDL_UpdateRect(dsurface,0,0,0,0);                             	
		SDL_Flip(dsurface);
		dest.y=y;
	}	
	


	
}


void displaycood(SDL_MouseMotionEvent *wmotion){

        	printf("Mouse moved to: (%d, %d)\n", wmotion->x, wmotion->y);
		printf("Relative motion: (%d, %d)\n", wmotion->xrel, wmotion->yrel);
}

void updateScore(SDL_Surface *sscreen,SDL_Surface *starget, int z, int y, int x) {
	static int score[]={0,0,0};
	SDL_Rect src, dest;
	int count;

	if (z|y|x){
		score[0]=z;
		score[1]=y;
		score[2]=x;
	
	}
	src.w=10, src.h=10;
	dest.y=20, dest.w=src.w, dest.h=src.h;
	for (count=0;count<3;count++) {
		switch(score[count]) {

			case 0:
				src.x=320;
				src.y=69;
				break;
	
			case 1:
				src.x=330;
				src.y=69;
				break;
			case 2:
				src.x=320;
				src.y=79;
				break;

			case 3:
				src.x=330;
				src.y=79;
				break;
			case 4:
				src.x=320;
				src.y=91;
				break;
			case 5: src.x=330;
				src.y=91;
				break;
			case 6:
				src.x=320;
				src.y=101;
				break;
			case 7: 
				src.x=330;
				src.y=101;
				break;
				
			case 8: src.x=320;
				src.y=112;
				break;

			case 9: src.x=330;
				src.y=112;
				break;
	
				
		}
	
		switch(count) {
			case 0:
				dest.x=20;
				break;
			case 1: dest.x=30;
				break;
				
			case 2: dest.x=40;
				break;
		}
	
	
		SDL_BlitSurface(starget, &src, sscreen, &dest);
	}


	
	
}


	
